luogu UVA12983ybtoj例题3树状数组严格上升子序列数&The Battle of Chibi

Posted SSL_ZZL

tags:

篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了luogu UVA12983ybtoj例题3树状数组严格上升子序列数&The Battle of Chibi相关的知识,希望对你有一定的参考价值。

【例题3】严格上升子序列数 & The Battle of Chibi


Link

luogu UVA12983
ybtoj 【树状数组课堂过关】【例题3】严格上升子序列数
题面//因为不知道侵不侵权所以就是题面是私密的,有账号的直接看题目转送门就可了


题目大意

请你在一个长度为n的数字序列中找到长度为m的严格上升子序列的个数(注意不是子串),答案对 1 0 9 + 7 10^9+7 109+7取模。


解题思路

因为这题才终于按下暴躁去注册了UVA账号,注册的时候一遍一遍地翻译:(

f [ i ] [ j ] f[i][j] f[i][j]为以 i i i结尾,长度为 j j j的严格上升子序列的个数
转移方程: f [ i ] [ j ] = ∑ 1 ⩽ i , 1 ⩽ j i ⩽ n , j ⩽ m f [ k ] [ j − 1 ] ( k < i , s [ k ] < s [ i ] ) f[i][j] = \\sum^{i\\leqslant n,j\\leqslant m}_{1\\leqslant i,1\\leqslant j}f[k][j-1]_{(k<i,s[k]<s[i])} f[i][j]=1i,1jin,jmf[k][j1](k<i,s[k]<s[i])
O ( n 2 m ) O(n^2m) O(n2m),耶,完美TLE

可以发现 k k k可以用树状数组代替
先离散化
i i i为结尾、长度为 j j j时,转移方程,维护树状数组
(具体看代码、注释)


Code

#include <algorithm>
#include <iostream>
#include <cstring>
#include <cstdio>
#define ll long long

using namespace std;

const ll P = 1000000007;
struct DT{
	int i, x;
	ll s;
}a[1010];
int n, m, T, now;
ll f[1010][1010], tree[1010][1010], ans;

bool cmp1(const DT&k, const DT&l) {return (k.s < l.s);}

bool cmp2(const DT&k, const DT&l) {return (k.i < l.i);};

void lsh() {  
	sort(a + 1, a + 1 + n, cmp1);
	a[1].x = 1;
	for(int i = 2, k = 1; i <= n; i++) {
		if (a[i].s != a[i - 1].s) k++;
		a[i].x = k;
	}
	sort(a + 1, a + 1 + n, cmp2);
}

int lowbit(int x) {return (x & -x);}

ll sum(int x, int y) {
	ll ans = 0;
	for(; x; x -= lowbit(x))
		ans = (ans + tree[x][y]) % P;
	return ans;
}

void add(int x,int y, ll z) {
	for(; x <= n; x += lowbit(x))
		tree[x][y] = (tree[x][y] + z) % P;
}

int main() {
	scanf("%d", &T);
	while(T--) {
		scanf("%d %d", &n, &m);
		for(int i = 1; i <= n; i++) {
			scanf("%lld", &a[i].s);
			a[i].i = i;
		}
		lsh();  //li san hua
		for(int i = 1; i <= n; i++)
			for (int j = 1; j <= m; j++) {
				if (j == 1) f[i][1] = 1;  //以i结尾、长度为j的上升子序列就只有它本身,所以方案为1
					else f[i][j] = sum(a[i].x - 1, j - 1) % P;  //比a[i]小(即k),且长度为j-1,就可以转移
				add(a[i].x, j, f[i][j]);  //维护树状数组
			}
		for(int i = m; i <= n; i++)  //因为长度为m,所以至少序列为1~m,换言之,m以前的位置没有m长度的序列
			ans = (ans + f[i][m]) % P;  //累计长度为m的严格上升子序列方案
		printf("Case #%d: %lld\\n", ++now, ans);
		
		ans = 0;
		memset(tree, 0, sizeof(tree));
		memset(f, 0, sizeof(f));
	}
} 

以上是关于luogu UVA12983ybtoj例题3树状数组严格上升子序列数&The Battle of Chibi的主要内容,如果未能解决你的问题,请参考以下文章

luogu P4514ybtoj树状数组课堂过关差分 例题6区间修改区间查询 & 上帝造题的七分钟

UVA12983 The Battle of Chibi

UVA12983 The Battle of Chibi 树状数组+DP

luogu P5020ybtoj背包问题课堂过关DP例题2货币系统 & NOIP2018 提高组货币系统

luogu P4513ybtoj线段树课堂过关例题3小白逛公园

luoguP1908ybtoj树状数组例题2逆序对